### `ntp-keygen` - generate public and private keys

from Alice's Adventures in Wonderland, Lewis Carroll

Alice holds the key.

Last update: July 5, 2008

#### Related Links

#### Table of Contents

- Synopsis
- Description
- Running the program
- Trusted Hosts and Secure Groups
- Identity Schemes
- Command Line Options
- Random Seed File
- Cryptographic Data Files
- Bugs

#### Synopsis

`ntp-keygen [ -cdeMPT ] [ -c [RSA-MD2 | RSA-MD5 | RSA-SHA | RSA-SHA1 | RSA-MDC2 | RSA-RIPEMD160 | DSA-SHA | DSA-SHA1 ] ] [ -H } [ -i issuername ] [ -p passwd2 ] [ -q passwd1 ] [ -S [ RSA | DSA ] ] [ -s subjectame ] [ -V nkeys ]`

#### Description

This program generates cryptographic data files used by the NTPv4 authentication and identity schemes. It generates MD5 keys used in symmetric key cryptography and, if the OpenSSL software library has been installed, it generates host keys, certificates and identity keys used in the Autokey public key cryptography. The symmetric keys file is generated in a format compatable with NTPv3 and also used with NTPv4. All other files are in PEM-encoded printable ASCII format so they can be embedded as MIME attachments in mail to other sites and certificate authorities.

When used to generate symmetric keys, the program produces a file containing 16 random keys. If this is the only need, run `ntp-keygen` with the `-M` option and disregard the remainder of this page. The file can be edited later with purpose-chosen passwords. Each line of the file contains three fields, first an integer between 1 and 65534, inclusive, representing the key identifier used in the `server` and `peer` configuration command. Next is the single character `M` to designate the key as MD5. Finally is the key itself from 1 to 31 characters chosen from the printable ASCII set with the exclusion of space and #. As is custom, # and the remaining chacters on the line are ignored.

Generated files are compatible with other OpenSSL applications and other Public Key Infrastructure (PKI) resources. Certificates generated by this program should be compatible with extant industry practice, although some users might find the interpretation of X509v3 extension fields somewhat liberal. However, the identity keys are probably not compatible with anything other than Autokey.

Most files used by this program are encrypted using a private password. The `-p` option specifies the password for local files and the `-q` option the password for files to be sent to remote sites. If no local password is specified, the string returned by the Unix `gethostname()` function is used. If no remote password is specified, the local password is used.

The `ntpd` command `crypto pw` specifies the read password for previously encrypted files. This must match the local password used by this program. If not specified, the host name is used. Thus, if files are generated by this program without password, they can be read back by `ntpd` without password, but only on the same host.

All files and links are installed by default in the keys directory `/usr/local/etc`, which is normally in a shared filesystem in NFS-mounted networks. The location of the keys directory can be changed by the `keysdir` configuration command. Normally, encrypted files for each host are generated by that host and used only by that host, although exceptions exist as noted later on this page.

This program directs commentary and error messages to the standard error stream `stderr` and remote files to the standard output stream `stdout` where they can be piped to other aplications or redirected to a file. The names used for generated files and links all begin with the string `ntpkey` and include the file type, generating host and filestamp, as described in the Cryptographic Data Files section below

#### Running the Program

To test and gain experience with Autokey concepts, log in as root and change to the keys directory, usually `/usr/local/etc.` When run for the first time, or if all files with names beginning `ntpkey` have been removed, use the `ntp-keygen` command without arguments to generate a default RSA host key and matching RSA-MD5 certificate with expiration date one year hence. If run again, the program uses the same host key, but generates a new certificate with new expiration date one year hence.

Run the command on as many hosts as necessary. Designate one of them as the trusted host (TH) using `ntp-keygen` with the `-T` option and configure it to synchronize from reliable Internet servers. Then configure the other hosts to synchronize to the TH directly or indirectly. A certificate trail is created when Autokey asks the immediately ascendant host towards the root to sign its certificate, which is then provided to the immediately descendant host on request. All group hosts should have acyclic certificate trails ending on the TH.

The host key is used to encrypt the cookie when required and so must be RSA type. By default, the host key is also the sign key used to encrypt signatures. A different sign key can be assigned using the `-S` option and this can be either RSA or DSA type. By default, the message digest type is MD5, but any combination of sign key type and message digest type supported by the OpenSSL library can be specified using the `-c` option.

#### Trusted Hosts and Secure Groups

As described on the Authentication Options page, an NTP secure group consists of one or more low-stratum THs as the root from which all other group hosts derive synchronization directly or indirectly. For authentication purposes all hosts in a group must have the same group name specified by the `-i` option and matching the `crypto ident` command option. The group name is used in the subject and issuer fields of trusted certificates and when constructing the file names for identity keys. All hosts must have different host names specified by the `-s` option and matching the `crypto host` command option. Host names are used in the subject and issuer fields of nontrusted certificates and when constructing the file names for host and sign keys and certificats. Host and group names are used only for authentication purposes and have nothing to do with DNS names.

#### Identity Schemes

As described on the Authentication Options page, there are five identity schemes, three of which - IFF, GQ and MV - require identity keys specific to each scheme. There are two files for each scheme, an encrypted keys file and a nonencrypted parameters file. In general, servers use the keys file and clients use the parameters file. In general, servers expecting to support a client population ned the keys file while others need only the parameters file. Both files are generated by the TA on behalf of all servers and clients in the group.

The parameters files are public; they can be stored in a public place and sent in the clear. The keys files are encrypted with the local password. To retrieve the keys file, a host sends a mail request to the TA including its local password. The TA encrypts the keys file with this password and returns it as an attachment. The attachment is then copied intact to the keys directory with name given in the first line of the file, but all in lower case and with the filestamp deleted..

For example, the TA can generate IFF keys, trusted certificate and parameter using the command

`ntp-keygen -p local_passwd -T -I -e >parameters_file`

where the -e option redirects the `parameters_file` to the standard output stream for a mail application or stored locally for later distribution.

``

#### Command Line Options

`-c [ RSA-MD2 | RSA-MD5 | RSA-SHA | RSA-SHA1 | RSA-MDC2 | RSA-RIPEMD160 | DSA-SHA | DSA-SHA1 ]`
  Select certificate and message digest/signature encryption scheme. Note that RSA schemes must be used with a RSA sign key and DSA schemes must be used with a DSA sign key. The default without this option is `RSA-MD5`.
`-d`
  Enable debugging. This option displays the cryptographic data produced for eye-friendly billboards.
`-e`
  Generate unencrypted IFF or GQ parameters file from existing key file `IFFkey`. or `GQkey` file, respectively. The file contents are sent to the standard output stream `stdout`. Note: Unencrypted Q parameter files should be used with caution, as a host in possesion of this file can masquerade as a group member. Use the GQ encrypted keys fiie instead.
`-G`
  Generate GQ key file `GQkey` and link `gqkey` for the Guillou-Quisquater (GQ) identity scheme.
`-H`
  Generate a new public/private host keys `RSAkey`, and link `host`.
`-I`
  Generate a new encrypted IFF key file `IFFkey` and link `iffkey` for the Schnorr (IFF) identity scheme.
`-i group`
  Set the group name to `group` for generated identity files. This is useful only if the TA is not a group member and is generally considered not a good practice.
`-M`
  Generate a new MD5 key file.
`-P`
  Generate a new private certificate used by the PC identity scheme. By default, the program generates public certificates. Note: the PC identity scheme is not recommended for new installations.
`-p passwd`
  Set the password for writing encrypted files to `passwd`. By default, the write password is the read password.
`-q passwd`
  Set the password for reading encrypted files to `passwd`. By default, the read password is the host name.
`-S [ RSA | DSA ]`
  Generate a new sign key of the designated type. By default, the sign key is the host key.
`-s name`
  Set the host name to `name`. This is used in the host and sign key file names, as well as the subject and issuer names in the certificate. It must match the host name specified in the `CRYPTO` configuration command.
`-T`
  Generate a trusted certificate. By default, the program generates nontrusted certificates.
`-V nkeys`
  Generate server parameters `MV` and `nkeys` client keys for the Mu-Varadharajan (MV) identity scheme. Note: support for this option should be considered a work in progress.

#### Random Seed File

All cryptographically sound key generation schemes must have means to randomize the entropy seed used to initialize the internal pseudo-random number generator used by the OpenSSL library routines. If a site supports `ssh`, it is very likely that means to do this are already available. The entropy seed used by the OpenSSL library is contained in a file, usually called `.rnd`, which must be available when starting the `ntp-keygen` program or `ntpd` daemon.

The OpenSSL library looks for the file using the path specified by the `RANDFILE` environment variable in the user home directory, whether root or some other user. If the `RANDFILE` environment variable is not present, the library looks for the `.rnd` file in the user home directory. Since both the `ntp-keygen` program and `ntpd` daemon must run as root, the logical place to put this file is in `/.rnd` or `/root/.rnd`. If the file is not available or cannot be written, the program exits with a message to the system log.

#### Cryptographic Data Files

File and link names are in the form `ntpkey_key_name.fstamp`, where `key` is the key or parameter type, `name` is the host or group name and `fstamp` is the filestamp (NTP seconds) when the file was created). By convention, key fields in generated file names include both upper and lower case alphanumeric characters, while key fields in generated link names include only lower case characters. The filestamp is not used in generated link names.

The key type is a string defining the cryptographic function. Key types include public/private keys `host` and `sign`, certificate `cert` and several challenge/response key types. By convention, files used for challenges have a `par` subtype, as in the IFF challenge `IFFpar`, while files for responses have a `key` subtype, as in the GQ response `GQkey`.

All files begin with two nonencrypted lines. The first line contains the file name in the format `ntpkey_key_host.fstamp`. The second line contains the datestamp in conventional Unix `date` format. Lines beginning with `#` are ignored.

The remainder of the file contains cryptographic data encoded first using ASN.1 rules, then encrypted using the DES-CBC algorithm and given password and finally written in PEM-encoded printable ASCII text preceded and followed by MIME content identifier lines.

The format of the symmetric keys file is somewhat different than the other files in the interest of backward compatibility. Since DES-CBC is deprecated in NTPv4, the only key format of interest is MD5 alphanumeric strings. Following the header the keys are entered one per line in the format

`keyno type key`

where `keyno` is a positive integer in the range 1-65,535, `type` is the string `MD5` defining the key format and `key` is the key itself, which is a printable ASCII string 16 characters or less in length. Each character is chosen from the 93 printable characters in the range 0x21 through 0x7f excluding space and the '#' character.

Note that the keys used by the `ntpq` and `ntpdc` programs are checked against passwords requested by the programs and entered by hand, so it is generally appropriate to specify these keys in human readable ASCII format.

The `ntp-keygen` program generates a MD5 symmetric keys file `ntpkey_MD5key_hostname.filestamp`. Since the file contains private shared keys, it should be visible only to root and distributed by secure means to other subnet hosts. The NTP daemon loads the file `ntp.keys`, so `ntp-keygen` installs a soft link from this name to the generated file. Subsequently, similar soft links must be installed by manual or automated means on the other subnet hosts. While this file is not used with the Autokey Version 2 protocol, it is needed to authenticate some remote configuration commands used by the `ntpq` and `ntpdc` utilities.

#### Bugs

It can take quite a while to generate some cryptographic values, from one to several minutes with modern architectures such as UltraSPARC and up to tens of minutes to an hour with older architectures such as SPARC IPC.